/*
 * Copyright 2006 Sony Computer Entertainment Inc.
 *
 * Licensed under the MIT Open Source License, for details please see license.txt or the website
 * http://www.opensource.org/licenses/mit-license.php
 *
 */
#ifndef __COLLADA_FX__PCH_H__
#define __COLLADA_FX__PCH_H__

//These shouldn't be necessary.
//#include <assert.h>
//#include <stdio.h>
//#include <stdarg.h>
#include <stdlib.h>
//#include <string.h>
#include <math.h>
//#include <cstdlib>
//#include <iostream>
//#include <string>
#include <vector>

#ifdef _WIN32 
#define NOMINMAX
//#define WIN32_LEAN_AND_MEAN	
//glu.h wants APIENTRY defined.
#include <windows.h> 
//These conflict with ColladaDOM/the schemas.
#undef VOID
#undef RELATIVE
#undef CONST
#undef RGB
#endif

//2017: Trying to simplify Cg/OpenGL set up.
#define GL_GLEXT_PROTOTYPES
#include <Cg/cgGL.h> 
#ifdef NDEBUG
#error Remove GLU (gluPerspective/gluLookat)
#endif
#ifdef SN_TARGET_PS3
//Can't say what these all do without a PS3.
#include <PSGL/psgl.h>
#include <PSGL/psglu.h> //Can do without.
#include <GLES/gl.h>
#include <GLES/glext.h>
#elif defined(__APPLE__)
#include <OpenGL/glu.h> //Can do without.
#include <OpenGL/glext.h>
#else
#include <gl/glu.h> //Can do without.
#include <gl/glext.h>
#endif

#ifndef COLLADA_DOM
#define COLLADA_DOM 3
#endif
#define COLLADA_NOLEGACY
#include <ColladaDOM.inl>
#include "../../xmlns/http_www_collada_org_2005_11_COLLADASchema/config.h"

#if COLLADA_DOM_GENERATION!=1
#error The below inclusion guards expect COLLADA_DOM_GENERATION to be equal to 1.
#endif
#ifndef __COLLADA_h__http_www_collada_org_2005_11_COLLADASchema__ColladaDOM_g1__
//These lines suppress the inclusion of these rather large chunks of this schema.
//If including code uses them it must include them before this header is included.
#if !defined(PRECOMPILING_COLLADA_FX)
#define __profile_CG_h__http_www_collada_org_2005_11_COLLADASchema__ColladaDOM_g1__
#endif //GLES/GLSL should go inside the above block if they are to be implemented.
#define __profile_GLES_h__http_www_collada_org_2005_11_COLLADASchema__ColladaDOM_g1__
#define __profile_GLSL_h__http_www_collada_org_2005_11_COLLADASchema__ColladaDOM_g1__
#define COLLADA_DOM_LITE
#include COLLADA_(http_www_collada_org_2005_11_COLLADASchema,(effect))
#include COLLADA_(http_www_collada_org_2005_11_COLLADASchema,(material))
#undef COLLADA_DOM_LITE
#endif

COLLADA_(namespace)
{
	namespace FX
	{
		namespace xs = ::COLLADA::DAEP::xs;
		namespace Collada05_XSD = ::COLLADA::http_www_collada_org_2005_11_COLLADASchema;
		namespace Collada05 = ::COLLADA::DAEP::http_www_collada_org_2005_11_COLLADASchema;
	}
}

#endif //__COLLADA_FX__PCH_H__
/*C1071*/