/*
 * Copyright 2006 Sony Computer Entertainment Inc.
 *
 * Licensed under the MIT Open Source License, for details please see license.txt or the website
 * http://www.opensource.org/licenses/mit-license.php
 *
 */
#ifndef __COLLADA_FX__PASS_H__
#define __COLLADA_FX__PASS_H__

#include "cfxEffect.h"

COLLADA_(namespace)
{
	namespace FX
	{//-.
//<-----'

class Shader : public FX::Annotatable, public FX::Paramable
{
COLLADA_(public)

	FX::Pass *Pass;

	CGprofile Cg_Profile;
	CGprogram Cg_Program;
	CGstate Cg_State; 
	CGstateassignment Cg_Assignment;

COLLADA_(public)

	using Paramable::Apply;

	Shader(FX::Pass*, CGGLenum, xs::ID main, xs::string args);
};

class Pass : public FX::Annotatable
{
COLLADA_(public)

	//SCHEDULED FOR REMOVAL
	FX::Technique *Technique;
		
	std::vector<FX::Shader*> Shaders;

	/**
	 * Previously "pass." 
	 * Capitalizing "pass" conflicts with the constructor.
	 * (All Cg variables should be distinguished eventually.)
	 */
	CGpass Cg;

COLLADA_(public)

	Pass(FX::Technique *technique, xs::ID sid)
	:Technique(technique)
	{
		Cg = cgCreatePass(Technique->Cg,sid);
	}
	~Pass()
	{
		for(size_t i=0;i<Shaders.size();i++)
		delete Shaders[i];
	}

	void Apply()
	{
		for(size_t i=0;i<Shaders.size();i++)
		Shaders[i]->Apply();
	}
};

//-------.
	}//<-'
}

#endif //
/*C1071*/