/*
 * Copyright 2006 Sony Computer Entertainment Inc.
 *
 * Licensed under the MIT Open Source License, for details please see license.txt or the website
 * http://www.opensource.org/licenses/mit-license.php
 *
 */
#include <FX.pch.h> //PCH

#include "cfxEffect.h"
#include "cfxPass.h"

COLLADA_(namespace)
{
	namespace FX
	{//-.
//<-----'

FX::Shader::Shader(FX::Pass *pass, CGGLenum stage, xs::ID main, xs::string args)
:Pass(pass),Cg_Profile(cgGLGetLatestProfile(stage))
{						 	
	xs::string args_0[2] = { args,nullptr };

	FX::Technique *tech = Pass->Technique;
	CGcontext Cg = tech->FindEffect()->Cg_Context;
	if(tech->Cg_Code.empty()) //C++98/03 support
	return;

	//From the looks of things there's no way to know
	//if the code is binary or not.
	CGenum cg_file_type;
	for(size_t i=0;i<2;i++)
	{
		//Is this necessary?
		#ifdef SN_TARGET_PS3 	
		cg_file_type = i==0?CG_BINARY:CG_SOURCE;
		#else
		cg_file_type = i==0?CG_OBJECT:CG_SOURCE;
		#endif	
		Cg_Program = cgCreateProgram(Cg,cg_file_type,&tech->Cg_Code[0],Cg_Profile,main,args_0);
		if(Cg_Program!=nullptr)
		break;
		if(i==0) daeEH::Warning<<
		"(False alarm? Failed to load as binary shader. Trying to compile...)";
	}

	if(Cg_Program==nullptr)
	{
		daeEH::Error<<"Failed to loaded Cg program.";
		return;
	}
	else daeEH::Verbose<<"Loaded Cg program.";

	if(stage==CG_GL_VERTEX)
	{
		daeEH::Verbose<<"Vertex program "<<main;
		Cg_State = cgGetNamedState(Cg,"VertexProgram");
	}
	else if(stage==CG_GL_FRAGMENT)
	{
		daeEH::Verbose<<"Fragment program "<<main;
		Cg_State = cgGetNamedState(Cg,"FragmentProgram");
	}
	else daeEH::Error<<"Unsupported target profile.";

	Cg_Assignment = cgCreateStateAssignment(Pass->Cg,Cg_State);

	cgSetProgramStateAssignment(Cg_Assignment,Cg_Program);	
}

//-------.
	}//<-'
}

/*C1071*/